"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Imports: Dependencies
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const datetimepicker_1 = __importDefault(require("@react-native-community/datetimepicker"));
const react_native_modal_1 = __importDefault(require("react-native-modal"));
const moment_1 = __importDefault(require("moment"));
// Screen Dimensions
const { height, width } = react_native_1.Dimensions.get('window');
// Component: Date Range Picker
const DateRangePicker = (props) => {
    // React Hooks: State
    const [fromDateModalVisible, toggleFromDate] = react_1.useState(false);
    const [toDateModalVisible, toggleToDate] = react_1.useState(false);
    const [androidFromDateVisible, toggleFromDateAndroid] = react_1.useState(false);
    const [androidToDateVisible, toggleToDateAndroid] = react_1.useState(false);
    const [tempToDate, setTempToDate] = react_1.useState(new Date());
    const [tempFromDate, setTempFromDate] = react_1.useState(new Date());
    const [fromDate, setFromDate] = react_1.useState(new Date());
    const [toDate, setToDate] = react_1.useState();
    // React Hooks: Lifecycle Methods
    react_1.useEffect(() => {
        // From Date Default Value
        props.onFromChange(fromDate);
    });
    // Toggle From Date Modal
    const toggleFromDateModal = () => {
        try {
            // Check Platform (iOS)
            if (react_native_1.Platform.OS === 'ios') {
                // React Hook: Toggle Modal
                toggleFromDate((fromDateModalVisible) => !fromDateModalVisible);
            }
            // Check Platform (Android)
            else if (react_native_1.Platform.OS === 'android') {
                // React Hook: Toggle Android
                toggleFromDateAndroid((androidFromDateVisible) => !androidFromDateVisible);
            }
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Toggle To Date Modal
    const toggleToDateModal = () => {
        try {
            // Check Platform (iOS)
            if (react_native_1.Platform.OS === 'ios') {
                // React Hook: Toggle Modal
                toggleToDate((toDateModalVisible) => !toDateModalVisible);
            }
            // Check Platform (Android)
            else if (react_native_1.Platform.OS === 'android') {
                // React Hook: Toggle Android
                toggleToDateAndroid((androidToDateVisible) => !androidToDateVisible);
            }
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Select From Date
    const selectFromDate = async (event, date) => {
        try {
            // Check Platform: Android
            if (react_native_1.Platform.OS === 'android') {
                // Undefined
                if (date === undefined) {
                    // React Hook: Toggle From Date Android 
                    toggleFromDateAndroid((androidFromDateVisible) => !androidFromDateVisible);
                }
                // Event Type: Set Date
                else if (event.type === 'set') {
                    // React Hook: Toggle Android 
                    toggleFromDateAndroid((androidFromDateVisible) => !androidFromDateVisible);
                    // React Hook: Set From Date
                    setFromDate(date);
                    // React Props: onChange
                    await props.onFromChange(date);
                }
                // Event Type: Dismissed
                else if (event.type === 'dismissed') {
                    // React Hook: Toggle Android
                    toggleFromDate(false);
                }
            }
            // Check Platform: Android
            else if (react_native_1.Platform.OS === 'ios') {
                setTempFromDate(date);
                // React Props: onChange
                await props.onFromChange(date);
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    // Select To Date
    const selectToDate = async (event, date) => {
        try {
            // Check Platform: Android
            if (react_native_1.Platform.OS === 'android') {
                // Undefined
                if (date === undefined) {
                    // React Hook: Toggle From Date Android 
                    toggleToDateAndroid((androidToDateVisible) => !androidToDateVisible);
                }
                // Event Type: Set Date
                else if (event.type === 'set') {
                    // React Hook: Toggle Android 
                    toggleToDateAndroid((androidToDateVisible) => !androidToDateVisible);
                    // React Hook: Set To Date
                    setToDate(date);
                    // React Props: onChange
                    await props.onToChange(date);
                }
                // Event Type: Dismissed
                else if (event.type === 'dismissed') {
                    // React Hook: Toggle Android
                    toggleToDate(false);
                }
            }
            // Check Platform: Android
            else if (react_native_1.Platform.OS === 'ios') {
                setTempToDate(date);
                // React Props: onChange
                await props.onToChange(date);
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render From iOS Date Picker
    const renderFromIOSDatePicker = () => {
        try {
            return (react_1.default.createElement(datetimepicker_1.default, { mode: "date", value: tempFromDate !== undefined ? tempFromDate : fromDate, onChange: (event, date) => selectFromDate(event, date) }));
        }
        catch (error) {
            console.log(error);
        }
    };
    // Press Cancel (From Date)
    const pressCancelFromDate = () => {
        try {
            // React Hook: Set Temp Date
            setTempFromDate(fromDate);
            // Toggle Modal
            toggleFromDateModal();
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Press Done (From Date)
    const pressDoneFromDate = () => {
        try {
            // React Hook: Set Date
            setFromDate(tempFromDate);
            // Props: onChange
            props.onFromChange(fromDate);
            // Toggle Modal
            toggleFromDateModal();
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render To iOS Date Picker (To Date)
    const renderToIOSDatePicker = () => {
        try {
            return (react_1.default.createElement(datetimepicker_1.default, { mode: "date", value: tempToDate !== undefined ? tempToDate : toDate, onChange: (event, date) => selectToDate(event, date) }));
        }
        catch (error) {
            console.log(error);
        }
    };
    // Press Cancel (To Date)
    const pressCancelToDate = () => {
        try {
            // React Hook: Set Temp Date
            setTempToDate(toDate);
            // Toggle Modal
            toggleToDateModal();
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Press Done (To Date)
    const pressDoneToDate = () => {
        try {
            // React Hook: Set Date
            setToDate(tempToDate);
            // Props: onChange
            props.onToChange(toDate);
            // Toggle Modal
            toggleToDateModal();
            // Dismiss Keyboard
            react_native_1.Keyboard.dismiss();
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render To Date Android Picker
    const renderToDateAndroidPicker = () => {
        try {
            if (androidToDateVisible === true) {
                return (react_1.default.createElement(datetimepicker_1.default, { mode: "date", display: props.mode, value: toDate, onChange: (event, date) => selectToDate(event, date) }));
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render From Date Android Picker
    const renderFromDateAndroidPicker = () => {
        try {
            if (androidFromDateVisible === true) {
                return (react_1.default.createElement(datetimepicker_1.default, { mode: "date", display: props.mode, value: fromDate, onChange: (event, date) => selectFromDate(event, date) }));
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    return (react_1.default.createElement(react_native_1.View, { style: styles.container },
        react_1.default.createElement(react_native_1.View, { style: styles.inputTitleContainer },
            react_1.default.createElement(react_native_1.Text, { style: styles.inputTitle }, props.title === undefined ? 'Date Range' : props.title)),
        react_1.default.createElement(react_native_1.View, { style: styles.toFromDateContainer },
            react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => toggleFromDateModal(), style: styles.dateInfoContainer },
                react_1.default.createElement(react_native_1.Text, { style: styles.dateText }, "From"),
                react_1.default.createElement(react_native_1.Text, { style: styles.text }, moment_1.default(fromDate).format('MMM Do, YYYY'))),
            react_1.default.createElement(react_native_1.View, null, androidFromDateVisible === true ? renderFromDateAndroidPicker() : null),
            react_1.default.createElement(react_native_modal_1.default, { isVisible: fromDateModalVisible, style: styles.modal },
                react_1.default.createElement(react_native_1.View, { style: styles.modalContainer },
                    react_1.default.createElement(react_native_1.View, { style: styles.pickerHeaderContainer },
                        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => pressCancelFromDate() },
                            react_1.default.createElement(react_native_1.Text, { style: styles.cancelText }, "Cancel")),
                        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => pressDoneFromDate() },
                            react_1.default.createElement(react_native_1.Text, { style: styles.doneText }, "Done"))),
                    react_1.default.createElement(react_native_1.View, { style: styles.pickerContainer }, renderFromIOSDatePicker())))),
        react_1.default.createElement(react_native_1.View, { style: styles.divider }),
        react_1.default.createElement(react_native_1.View, { style: styles.toFromDateContainer },
            react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => toggleToDateModal(), style: styles.dateInfoContainer },
                react_1.default.createElement(react_native_1.Text, { style: styles.dateText }, "To"),
                react_1.default.createElement(react_native_1.Text, { style: styles.text }, toDate !== null ? moment_1.default(toDate).format('MMM Do, YYYY') : 'Select')),
            react_1.default.createElement(react_native_1.View, null, androidToDateVisible === true ? renderToDateAndroidPicker() : null),
            react_1.default.createElement(react_native_modal_1.default, { isVisible: toDateModalVisible, style: styles.modal },
                react_1.default.createElement(react_native_1.View, { style: styles.modalContainer },
                    react_1.default.createElement(react_native_1.View, { style: styles.pickerHeaderContainer },
                        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => pressCancelToDate() },
                            react_1.default.createElement(react_native_1.Text, { style: styles.cancelText }, "Cancel")),
                        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => pressDoneToDate() },
                            react_1.default.createElement(react_native_1.Text, { style: styles.doneText }, "Done"))),
                    react_1.default.createElement(react_native_1.View, { style: styles.pickerContainer }, renderToIOSDatePicker()))))));
};
// Styles
const styles = react_native_1.StyleSheet.create({
    container: {
        display: 'flex',
        width: width - 32,
        marginRight: 16,
        marginLeft: 16,
        justifyContent: 'center',
    },
    inputTitleContainer: {
        width: width,
        flexDirection: 'row',
        alignItems: 'center',
    },
    inputTitle: {
        alignSelf: 'flex-start',
        fontFamily: 'System',
        fontSize: 24,
        fontWeight: '700',
        color: '#000',
    },
    toFromDateContainer: {
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        height: 50,
    },
    dateInfoContainer: {
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        width: width - 32,
    },
    dateText: {
        fontFamily: 'System',
        fontSize: 17,
        fontWeight: '600',
        color: '#000',
    },
    text: {
        fontFamily: 'System',
        fontSize: 17,
        fontWeight: '400',
        color: '#007AFF',
    },
    arrowForward: {
        color: 'black',
        opacity: .3,
        marginRight: 7,
    },
    divider: {
        borderColor: '#7D7D7D',
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
        marginTop: 12,
        marginBottom: 12,
    },
    modal: {
        margin: 0,
    },
    modalContainer: {
        height: '100%',
        alignItems: 'center',
        justifyContent: 'flex-end',
    },
    pickerHeaderContainer: {
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        height: 40,
        width: width,
        backgroundColor: '#FAFAF8',
        borderColor: '#7D7D7D',
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
    },
    pickerContainer: {
        height: 220,
        width: width,
        backgroundColor: 'white',
    },
    doneText: {
        fontFamily: 'System',
        color: '#007AFF',
        fontWeight: '600',
        fontSize: 17,
        marginRight: 16,
    },
    cancelText: {
        fontFamily: 'System',
        color: '#007AFF',
        fontWeight: '400',
        fontSize: 17,
        marginLeft: 16,
    },
});
// Exports
exports.default = DateRangePicker;
